      program tts
      
c     radiative transfer in a disk+envelope around a star.
c     height of disk, z, goes as z1*r**b.
c     density goes as c*r**-a.
c     opacity is dust with either rayleigh or H-G phase function.
c     output is stokes parameters as a function of angle
c     
c     history:
c     2000/03/19 (mjw):  update version stamp for changes on 03/19.  Also,
c     change version name to VGER (from mctherm)
c     2003/12/08 (baw): change program name, I/O.
c     2003/12/23 (baw): add back in analytic scattering functions
c     
      
      integer iwav,MXWAV,nwav
      parameter (MXWAV=15)
      character cwav(MXWAV)*10,cfldust(MXWAV,4)*50,cvers*10,
     1     ctherm(MXWAV)*8
      real*8 akapd(MXWAV,4),ag(MXWAV,4),arlam(MXWAV,4),apl(MXWAV,4),
     1     awave(MXWAV)
      
      data cvers/'20040121a'/
      
      open(unit=12,file='disk.dat',status='unknown')
      write(12,'(a,a)')cvers,' - VGER version'
      
c     input and setup
      call setup(cwav,cfldust,ctherm,awave,akapd,ag,arlam,apl,
     1     nwav,MXWAV)
      
      do iwav=1,nwav
         
         call initarr
         
         call setup_wave(iwav,cfldust,ctherm,awave,akapd,ag,arlam,apl,
     1        MXWAV)
         
c     radiative transfer
         call disk
         
c     convert stokes arrays to flux arrays
         call diskflux
         
         call output(iwav,cwav,ctherm,MXWAV)

      end do
      
      close(12)
      
      
      end
