c     **********************************************************

      subroutine tauint(iphot,tsum,ii,r2p,eps,idust2)

      implicit none

      include 'taunum.txt'
      include 'tts.txt'
      include 'opacin.txt'
      include 'grid.txt'

      real*8 tsum,dt,opac,dtau,ds,beta,lp1,r2p,eps,deps
     1     ,rsqnew,xpnew,ypnew,zpnew,dtau_eps
      integer ioffset(3),ii(3),iphot,it,ir,ip,ir1,it1,ip1,idust2

      character routine*20
      routine='tauint_3d'
      tsum=0.d0

10    continue
      call testgrid(xp,yp,zp,rsq,rtot,ii,routine,iphot,r2p,uz)
      ir=ii(1)
      it=ii(2)
      ip=ii(3)
      idust2=dustarr(ir,it,ip)

      if (npg.gt.1.and.ntg.gt.1) then
         call find_wall(dt,ioffset,aarr(ip),aarr(ip+1),barr(ip)
     &        ,barr(ip+1),0.d0,0.d0,0.d0,0.d0,r2arr(ir),r2arr(ir+1)
     &        ,tan2arr(it),tan2arr(it+1),ux,uy,uz,xp,yp,zp)
c     print*,'dt ',dt
c     print*,'ioffsets ',ioffset(1),ioffset(2),ioffset(3)
      else if (ntg.gt.1) then
         call find_wall_2D(dt,ioffset,r2arr(ir),r2arr(ir+1)
     &        ,tan2arr(it),tan2arr(it+1),ux,uy,uz,xp,yp,zp)
      else
         call find_wall_1D(dt,ioffset,r2arr(ir),r2arr(ir+1)
     &        ,ux,uy,uz,xp,yp,zp)
      endif

c     print*,'dt,ir,r,arr(ir),rarr(ir+1)'
c     print*,dt,ir,dsqrt(rsq),rarr(ir),rarr(ir+1)
      if (dt.lt.0.d0) then
         print*,'problem with find_wall! did not find surface! '
         print*,'in tauint,ir,rtot2,r2arr(ir)',ir,rsq,r2arr(ir)
         print*,'ux,uy,uz,iphot',ux,uy,uz,iphot
         print*,'xtot,ytot,ztot',xp,yp,zp
         dt=eps*(rarr(ir+1)-rarr(ir))
c     stop
      endif

c     optical depth to edge of cell (add small amount because we
c     will increment distance by a small amount)
      opac=kapd(idust2)*densarr(ir,it,ip)
      deps=(rarr(ir+1)-rarr(ir))*eps
      dtau_eps=opac*deps
      if (dtau_eps.gt.0.01) then
         print*,''
         print*,'WARNING, in tauint_3d'
         print*,'deps is too big, opac*deps',dtau_eps
         print*,''
      endif
      dtau=opac*dt+dtau_eps
c     print*,'dtau,tau ',dtau,tau
c     test to see if tau is exceeded before cell wall reached.
c     if so, calculate distance where this happens.  
      if ((tsum+dtau).gt.tau) then
         ds=(tau-tsum)/opac
         xp=xp+ds*ux
         yp=yp+ds*uy
         zp=zp+ds*uz
         rsq=xp**2+yp**2+zp**2
         rtot=dsqrt(rsq)
c        we are done with optical depth integration
         go to 300
      endif

      ii(1)=ii(1)+ioffset(1)
      ii(2)=ii(2)+ioffset(2)
      ii(3)=ii(3)+ioffset(3)
c     account for crossing the phi=0 plane:
      if (ii(3).eq.0) ii(3)=npg-1
      if (ii(3).eq.npg) ii(3)=1

 50   xpnew=xp+(dt+deps)*ux
      ypnew=yp+(dt+deps)*uy
      zpnew=zp+(dt+deps)*uz
      rsqnew=xpnew*xpnew+ypnew*ypnew+zpnew*zpnew
      if ((rsqnew-rsq).eq.0.d0) then
         print*,''
         print*,'ERROR, in tauint_3d'
         print*,'rsqnew=rsq, step size too small'
         print*,'increasing deps',deps
         deps=deps*2.d0
         print*,'ir,rarr(ir),rarr(ir+1)',ir,rarr(ir),rarr(ir+1)
         if (deps.eq.0.d0) then
            print*,'deps=0'
            print*,'ir,rarr(ir),rarr(ir+1)',ir,rarr(ir),rarr(ir+1)
            print*,'fatal error'
            stop
         endif
         go to 50
      endif
      xp=xpnew
      yp=ypnew
      zp=zpnew
      rsq=rsqnew
      rtot=dsqrt(rsq)
      tsum=tsum+dtau

c     print*,'new rsq,ir,r2arr(ir),r2arr(ir+1)'
c     print*,(rsq),ii(1)
c     ir=ii(1)
c     print*,r2arr(ir)
c     print*,r2arr(ir+1)
c     print*,'new xp,yp,zp,rsq,rminsq ',xp,yp,zp,rsq,rminsq
c     print*,'r2arr(nrg),rminsq'
c     print*,r2arr(nrg)
c     print*,rminsq

c     testing to see if photon exits
      if (rsq.gt.r2arr(nrg)) then
c        photon exits system
         exitflag=1
         go to 300
      endif

      if (rsq.lt.r2arr(1)) then
c     print*,'rsq,rminsq ',rsq,r2arr(1)
         aflux=aflux+1.d0
         aflag=1
         go to 300
      endif

      go to 10

300   return
      stop
      end

